from re import X
import sys
import tkinter as tk
from tkinter import Y, ttk
import tkinter as tk
from tkinter import ttk
import tkinter.messagebox 
from PIL import Image, ImageTk, ImageOps
import os
import numpy as np
import matplotlib.pyplot as plt
from matplotlib import use as mpl_use
from math import log10
from scipy.signal import find_peaks, savgol_filter

"""output_pin = 7

from picamera2 import Picamera2
import RPi.GPIO as GPIO"""


# All the code from here to the first function is just code to initialaze everything
mpl_use("agg")
# Create the main window
window = tk.Tk()
WIDTH = window.winfo_screenwidth()
HEIGHT = window.winfo_screenheight()
window.geometry(f"{WIDTH}x{HEIGHT}")
window.attributes('-fullscreen', True)

window.title("Spektrofotometr")

pixel = tk.PhotoImage(width=1, height=1)

# Create different tabs for from_sample and laser
tabControl = ttk.Notebook(window)

from_sample = ttk.Frame(tabControl)
laser = ttk.Frame(tabControl)

tabControl.add(from_sample, text="Ze vzorku")
tabControl.add(laser, text="Laserem")

path_calibration = "C:/spektro/robert/kal"

# Pack all tabs
tabControl.pack(expand=1, fill="both")

img_out_size = (int(WIDTH / 4), int(HEIGHT / 3))
btn_width, btn_height = (int(img_out_size[0] / 2 - 50), int(img_out_size[1] / 8))
calc = False
first = True
mirror = False


# Next 6 functions are here to take pictures - for calibration using laser and or using the sample method
def take_picture_foo(file_name):
    """GPIO.output(7, True)
    time.sleep(0.5)
    file = open(f"{path_calibration}/{file_name}.jpg", 'wb')

    picam2.set_controls({"ExposureTime": int(current_exp), "AnalogueGain": float(current_gain)})
    time.sleep(1)
    for _ in range(1):
        picam2.capture_array('raw').tofile(file)

    file.close()

    picam2.capture_file(f"{path_calibration}/{file_name}.jpg")
    time.sleep(0.5)
    GPIO.output(7, False)"""
    return

def take_laser_img(file_name):
    take_picture_foo(file_name)
    return


def take_img_sample():
    take_picture_foo("sample_img_1")
    main()

def take_img_sample_2():
    take_picture_foo("sample_img_2")
    main()


def take_img_laser_1():
    take_laser_img("img_laser_1")
    main()


def take_img_laser_2():
    take_laser_img("img_laser_2")
    main()



# This function safely ends the whole programme
def end_program():
    #GPIO.cleanup()
    sys.exit()


# This function is used to convert .raw format image to PIL format image
def raw_to_img(raw_img):
    # At first it converts it to a numpy array
    img_arr = np.frombuffer(raw_img, np.uint8)
    # Then it calculates how many frames are present in the .raw stream
    num_of_frames = int(img_arr.size / (1520 * 3072))
    # Then it converts the .raw stream to a 3D array - first dimension is the frame number, second is x cordinate and third is y cordinate
    img_arr = img_arr.reshape(num_of_frames, 1520, 3072)
    # Than it creates the mean of all the images and converts it to PIL image
    mean = np.mean(img_arr, axis=0)
    mean = np.rint(mean).astype(np.uint8)
    image = Image.fromarray(mean)
    return image


# This function converts the PIL image to 1D list of intensity values
def convert_bggr_to_intensity(image):
    # At first it converts it to np array and creates the mean across all y values
    img_array = np.array(image)
    img_array = np.mean(img_array, axis=0)
    blank = []
    # Then it needs to average every 3 pixels to one, because the .raw stream is 12 bits and I use 8bits here (8 + 8 + 8 bits = 24 bits = two 12 bit pixels)
    for i in range(0, img_array.shape[0] - 33, 3):
        pixel_1 = img_array[i]
        pixel_2 = img_array[i + 1]
        pixel_3 = img_array[i + 2]
        average = int((pixel_1 / 3 + pixel_2 / 3 + pixel_3 / 3))
        blank.append(average)
    return blank



# This function creates a graph from the image "image" and saves it as "im_save_name"
def plot_graph(image, im_save_name):
    # It firsts converts it to a list of intensity values
    mean = convert_bggr_to_intensity(image)

    # Than it creates the graph
    fig = plt.figure(frameon=False)
    ax = fig.add_axes([0, 0, 1, 1])
    ax.axis()
    plt.ylabel("Light")
    plt.xlabel("Pixel")
    plt.ylim(0, 260)
    ax.plot(mean)

    # Save the graph as .png
    plt.savefig(f'{path_calibration}/{im_save_name}.png', bbox_inches='tight')
    plt.clf()
    plt.close()

    # Save the graph values so they can be accessed without opening the graph (this aproach is faster)
    f = open(f"{path_calibration}/just_val_{im_save_name}.txt", "w")
    for j in mean:
        try:
            j = str(int(j))
            f.write(j + "\n")
        except ValueError:
            j = str(j[0])
            f.write(j + "\n")
    f.close()



# This function is used to mirror the images, if needed
def mirror_img():
    global mirror
    if mirror:
        mirror = False
    else:
        mirror = True
    main()



# This function graphs the absorbance if using the sample calibration method
def graph_abs():
    # First it opens both sets of values created when creating the graphs of these images
    text_vals_1 = open(f"{path_calibration}/just_val_first_img_plt.txt", "r")
    text_vals_2 = open(f"{path_calibration}/just_val_second_img_plt.txt", "r")

    text_vals_1 = text_vals_1.readlines()
    text_vals_2 = text_vals_2.readlines()

    # Than it converts these values to absorbance
    absorbance = []
    for i, j in enumerate(text_vals_1):
        n = int(text_vals_1[i].strip("\n"))
        n2 = int(text_vals_2[i].strip("\n"))
        if n2 == 0:
            n2 = 1
        if n == 0:
            n = 1
        a = - log10(n2 / n)
        absorbance.append(a)
        
    
    # And this absorbance is then written to a file so it can be used again
    f = open(f"{path_calibration}/just_val_absorbance.txt", "w")
    if mirror:
        graph_absorbance = absorbance[::-1]
        for i in graph_absorbance:
            f.write(str(i) + "\n")

    else:
        graph_absorbance = absorbance
        for i in graph_absorbance:
            f.write(str(i) + "\n")
    f.close()

    # And finally the graph of the absorbance is created
    fig = plt.figure(frameon=False)
    ax = fig.add_axes([0, 0, 1, 1])
    ax.axis()
    plt.ylabel("Light")
    plt.xlabel("Pixel")

    ax.plot(graph_absorbance)

    # Save the graph as .png
    plt.title("Absorbance")
    plt.savefig(f"{path_calibration}/absorbance.png", bbox_inches='tight')
    plt.clf()
    plt.close()





# This saves all the calibration data if the sample method is used
def save_s():
    f = open(f"{path_calibration}/kalibrace.txt", "w")
    f.write(str(shift) + "|")
    f.write(str(multiply) + "|")
    f.write(str(shift_2) + "|")
    f.write(str(multiply_2))
    f.close()


# This saves all the calibration data if the laser method is used
def save_l():
    f = open(f"{path_calibration}/kalibrace.txt", "w")
    f.write(str(shift_l) + "|")
    f.write(str(multiply_l))
    f.close()

# This function is here only to create all the buttons for the sample method
def sample_buttons():
    calculate_s = tk.Button(from_sample, text="Calculate")
    calculate_s.config(height=btn_height, width=btn_width, image=pixel, compound="c")
    calculate_s.place(x=img_out_size[0] * 4 - btn_width - 25, y=1 * (btn_height + 20) + 25)
    calculate_s.configure(command=main)

    save = tk.Button(from_sample, text="Save")
    save.config(height=btn_height, width=btn_width, image=pixel, compound="c")
    save.place(x=img_out_size[0] * 4 - 2 * (btn_width + 25), y=1 * (btn_height + 20) + 25)
    save.configure(command=save_s)

    mirror_image = tk.Button(from_sample, text=f"Mirror images")
    mirror_image.config(height=btn_height, width=btn_width, image=pixel, compound="c")
    mirror_image.place(x=img_out_size[0] * 4 - btn_width - 25, y=2 * (btn_height + 20) + 25)
    mirror_image.configure(command=mirror_img)

# This function is here only to create all the buttons for the laser method
def laser_buttons():
    global wave_1_entry, wave_2_entry

    end = tk.Button(window, text="Exit")
    end.config(height=btn_height, width=btn_width, image=pixel, compound="c")
    end.place(x=img_out_size[0] * 4 - btn_width - 25, y=0 + 25)
    end.configure(command=end_program)


    save = tk.Button(laser, text="Save")
    save.config(height=btn_height, width=btn_width, image=pixel, compound="c")
    save.place(x=img_out_size[0] * 4 - 2 * (btn_width + 25), y=0 * (btn_height + 20) + 25)
    save.configure(command=save_l)

    calculate = tk.Button(laser, text="Calculate")
    calculate.config(height=btn_height, width=btn_width, image=pixel, compound="c")
    calculate.place(x=img_out_size[0] * 4 - btn_width - 25, y=2 * (btn_height + 20) + 25)
    calculate.configure(command=cal)


    # Define the button for taking the first picture
    getpic = tk.Button(laser, text="Get 1st pic")
    getpic.config(height=btn_height, width=btn_width, image=pixel, compound="c")
    getpic.place(x=img_out_size[0] * 4 - 2 * (btn_width + 25), y=btn_height + 20 + 25)
    getpic.configure(command=take_img_laser_1)

    # Define the button for taking the second picture
    getpic_2 = tk.Button(laser, text="Get 2nd pic")
    getpic_2.config(height=btn_height, width=btn_width, image=pixel, compound="c")
    getpic_2.place(x=img_out_size[0] * 4 - btn_width - 25, y=btn_height + 20 + 25)
    getpic_2.configure(command=take_img_laser_2)
    # endregion


    # region Parametrs
    wave_1_entry = tk.Entry(master=laser, width=6)
    wave_1_entry.place(x=img_out_size[0] * 4 - (50), y=3 * (btn_height + 20) + 25)
    tk.Label(master=laser, text=f"First sample wavelength").place(
        x=img_out_size[0] * 4 - 2 * (btn_width + 25), y=3 * (btn_height + 20) + 25)

    wave_2_entry = tk.Entry(master=laser, width=6)
    wave_2_entry.place(x=img_out_size[0] * 4 - (50), y=int(3.5 * (btn_height + 20)) + 25)
    tk.Label(master=laser, text=f"Second sample wavelength").place(x=img_out_size[0] * 4 - 2 * (btn_width + 25),
                                                                          y=int(3.5 * (btn_height + 20)) + 25)
    # endregion


# This function is used to convert the image to a single line
def img_to_line(file_name):
    img = np.array(Image.open((f"{path_calibration}/{file_name}.jpg")))
    img_array = np.mean(img, axis=0)
    l = []
    for j in (img_array):
        l.append(int(j[0]/3 + j[1]/3 + j[2]/3))

    return l


# This function calculates the shift of the sample method and creates the graphs
def graph_shifted():
    global shift, multiply, shift_2, multiply_2
    # First it reads the data of both the profesional spectrum and the absorbance measured by my machine
    f = open(f"{path_calibration}/just_val_absorbance.txt", "r")
    data_1 = f.readlines()
    f.close()
    # Here it finds the first three peaks in the data
    x_, x_2, x_1 = (peak(data_1, 3))
    f = open(f"{path_calibration}/profi.txt", "r")
    data_2 = f.readlines()
    f.close()
    X_, X_2, X_1 = (peak(data_2, 3))
    X_1 += 400
    X_2 += 400


    # Here it calculates the shift and multiply factors needed on the x axis
    shift = ((x_1 * X_2 - x_2 * X_1) / (X_1 - X_2))
    multiply = (X_1 / (x_1 + shift))
    y_1 = float(data_1[x_1])
    y_2 = float(data_1[x_2])
    y_ = float(data_1[x_])
    Y_1 = float(data_2[X_1 - 400])
    Y_2 = float(data_2[X_2 - 400])
    Y_ = float(data_2[X_])

    # Here it calculates the shift and multiply factors needed on the y axis
    shift_2 = ((Y_1 * y_2 - Y_2 * y_1) / (Y_2 - Y_1))
    shift_2 = -0.03
    multiply_2 = (Y_ / (y_ + shift_2))
    multiply_2 = 7.5

    my_data = data_1
    calib = data_2

    # These are used so that I can visualize how the programe tried to fit the data on each other
    peaks_1 = [(x_, x_1, x_2), ((y_+ shift_2) * multiply_2, (y_1+ shift_2) * multiply_2, (y_2+ shift_2) * multiply_2)]
    peaks_2 = [(X_, X_1, X_2), (Y_, Y_1, Y_2)]

    print(peaks_1)

    # Here I just convert the file data to graphable data
    mydata = []
    for i in my_data:
        mydata.append(float(i.strip("\n")))
    my_data = np.array(mydata)
    data = []
    for i in calib:
        data.append(float(i.strip("\n")))
    calib = np.array((data))
    xxx = list(range(len(my_data)))

    x = list(range(400, 631))
    

    # And finally, here I create the final graph
    plt.ylabel("Light")
    plt.xlabel("Pixel")
    plt.plot(x, calib, color="red")
    plt.plot((xxx + shift) * multiply, (my_data + shift_2) * multiply_2, color="blue")
    plt.plot((peaks_1[0] + shift) * multiply, peaks_1[1], "x", color="blue")
    plt.plot((peaks_2[0] + shift) * multiply, (peaks_2[1]), "x", color="red")

    # Save the graph as .png
    plt.show()
    plt.savefig(f'C:/spektro/robert/kal/graph_new.png')
    plt.close()


# This function finds the peaks in the data
def peak(data, num_of_peaks):
    # At first it sets the width of the peak to a high number - 100
    n = 100
    higher = False
    lower = False
    while n > 0:
        # It tries to find the peak with width = n
        peaks, _ = find_peaks(data, height=0, width=n, distance=15)
        # If the number of found peaks is less than the number needed, it decreases the width by 5
        if len(peaks) < num_of_peaks:
            n -= 5
            lower = True
        # If the number of peaks is more than the number needed, it increases the width by 1
        elif len(peaks) > num_of_peaks:
            n += 1
            higher = True
            lower = False
        else:
            break
        # If it can not find the exact number of peaks the while loop breaks and it uses the first peaks it found
        if higher and lower:
            peaks = peaks[:num_of_peaks]
            break

    return peaks

def cal():
    global calc
    calc = True
    main()


# This is the main function, it has all the calls for other functions as well as the main functionality
def main():
    global first, shift_l, multiply_l
    # If it is the first time this function is ran, it creates all the buttons
    if first:
        laser_buttons()
        sample_buttons()
        first = False
    # Then it tries to find the images
    sample_1 = os.path.exists(f"{path_calibration}/sample_img_1.jpg")
    sample_2 = os.path.exists(f"{path_calibration}/sample_img_2.jpg")
    laser_1 = os.path.exists(f"{path_calibration}/laser_img_1.jpg")
    laser_2 = os.path.exists(f"{path_calibration}/laser_img_2.jpg")
    kal = os.path.exists(f"{path_calibration}/profi.txt")


    # If the images are found, it displays them to their window
    if laser_1:
        pil_image_laser_1 = Image.open(f"{path_calibration}/laser_img_1.jpg")
        tk_image_laser_1 = ImageTk.PhotoImage(pil_image_laser_1.resize(img_out_size))
        tk.Label(laser, image=tk_image_laser_1).place(x=0 * img_out_size[0], y=0 * img_out_size[1])
    if laser_2:
        pil_image_laser_2 = Image.open(f"{path_calibration}/laser_img_2.jpg")
        tk_image_laser_2 = ImageTk.PhotoImage(pil_image_laser_2.resize(img_out_size))
        tk.Label(laser, image=tk_image_laser_2).place(x=1 * img_out_size[0], y=0 * img_out_size[1])

    # If all needed images have been found and the main function is ran by the "Calculate" button it tries to calculate the offset - shift and multiply
    if laser_1 and laser_2 and calc:
        x_1 = int(peak(img_to_line("laser_img_1"), 1))
        x_2 = int(peak(img_to_line("laser_img_2"), 1))

        X_1 = int(wave_1_entry.get())
        X_2 = int(wave_2_entry.get())


        shift_l = ((x_1 * X_2 - x_2 * X_1) / (X_1 - X_2))
        multiply_l = (X_1 / (x_1 + shift_l))
    
    # Again, the images are displayed
    if sample_1:
        pil_image_sample_1 = Image.open(f"{path_calibration}/sample_img_1.jpg")
        if mirror:
            pil_image_sample_1 = ImageOps.mirror(pil_image_sample_1)
        tk_image_sample_1 = ImageTk.PhotoImage(pil_image_sample_1.resize(img_out_size))
        tk.Label(from_sample, image=tk_image_sample_1).place(x=0 * img_out_size[0], y=0 * img_out_size[1])
    if sample_2:
        pil_image_sample_2 = Image.open(f"{path_calibration}/sample_img_2.jpg")
        if mirror:
            pil_image_sample_2 = ImageOps.mirror(pil_image_sample_2)
        tk_image_sample_2 = ImageTk.PhotoImage(pil_image_sample_2.resize(img_out_size))
        tk.Label(from_sample, image=tk_image_sample_2).place(x=1 * img_out_size[0], y=0 * img_out_size[1])
    
    # And if both images have been found, it calculates the shift and multiply at x and y axis
    if sample_1 and sample_2:
        if not kal:
            tk.messagebox.showinfo("Chybí kalibrační hodnoty",  f"Zadejte soubor z profesionálního přístroje do složky {path_calibration} se jménem profi.txt")
        else:
            file = open(f"{path_calibration}/sample_img_1.raw", "rb")
            raw_image = file.read()
            file.close()
            raw_image_1 = raw_to_img(raw_image)

            file = open(f"{path_calibration}/sample_img_2.raw", "rb")
            raw_image = file.read()
            file.close()
            raw_image_2 = raw_to_img(raw_image)

            plot_graph(raw_image_1, "first_img_plt")
            plot_graph(raw_image_2, "second_img_plt")

            graph_abs()
            plot_2_bg = Image.open(f"{path_calibration}/absorbance.png")
            plot_2_out_bg = ImageTk.PhotoImage(plot_2_bg.resize(img_out_size))
            tk.Label(window, image=plot_2_out_bg).place(x=2 * img_out_size[0], y=1 * img_out_size[1])

            graph_shifted()

            plot_2_bg_ = Image.open(f"{path_calibration}/graph_new.png")
            plot_2_out_bg_ = ImageTk.PhotoImage(plot_2_bg_.resize(img_out_size))
            tk.Label(window, image=plot_2_out_bg_).place(x=3 * img_out_size[0], y=1 * img_out_size[1])





    window.mainloop()

if __name__ == '__main__':
    main()